Subject: bug#55428: [feature/tree-sitter] Simplify the parser creation API

From: Eli Zaretskii <[email-masked]>
Date: Sun, 15 May 2022 17:26:11 +0300

> Date: Sun, 15 May 2022 16:15:57 +0200
> From:  Daniel Martín via "Bug reports for GNU Emacs,
>  the Swiss army knife of text editors" <[email-masked]>
> 
> 
> Currently, there are three functions to create a tree-sitter parser:
> 
> - treesit-get-parser-create
> - treesit-get-parser
> - treesit-parser-create
> 
> I think this set of similarly named functions can be reduced, so that
> developers don't need to remember a lot of APIs.  How I understand the
> problem of creating a tree-sitter parser is that we need three things
> from the developer:
> 
> - A programming language (a symbol).
> - A buffer (optional, default to the current buffer).
> - Whether to create or reuse an existing parser for that language.
> 
> I think it would be simpler to have just one parser creation API like
> 
> (treesit-make-parser LANGUAGE &optional BUFFER ALWAYS-NEW)

I suggest that discussions about the API be held on emacs-devel, not
hear.  That way, more people will see them and could decide whether to
participate.

Thanks.